Bug 1276588 (CVE-2015-8019)

Summary: CVE-2015-8019 kernel: net: buffer overflow when copying data from skbuff to userspace
Product: [Other] Security Response Reporter: Martin Prpič <mprpic>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED NOTABUG QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: agordeev, aquini, arm-mgr, bhu, carnil, dhoward, esammons, fhrbata, gansalmon, iboverma, itamar, jforbes, jkacur, joelsmith, jonathan, jross, jwboyer, kernel-maint, kernel-mgr, kstutsma, lgoncalv, lwang, madhu.chinakonda, matt, mchehab, mcressma, mguzik, nmurray, pholasek, plougher, rt-maint, rvrbovsk, slawomir, vdronov, williams
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-11-30 14:55:35 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1276589    
Bug Blocks: 1276590    

Description Martin Prpič 2015-10-30 08:55:52 UTC
The following flaw was reported in the kernel:

skb_copy_and_csum_datagram_iovec doesn't check the actual length of the iovec's buffers to which it copies data, then memcpy_toiovec can copy to an address that was not specified by userspace, but garbage lying on the kernel stack.

In some cases, this address can be a valid userspace address, to which memcpy_toiovec will write the buffers. This can happen when userspace calls write followed by recvmsg.

In that case, memcpy_toiovec will dump the packet contents to the buffer passed to the write call, and can for example overwrite stack contents.

Upstream patch:

http://patchwork.ozlabs.org/patch/530642/

CVE request and assignment:

http://seclists.org/oss-sec/2015/q4/177

Comment 1 Martin Prpič 2015-10-30 08:56:41 UTC
Created kernel tracking bugs for this issue:

Affects: fedora-all [bug 1276589]

Comment 2 Josh Boyer 2015-10-30 13:01:16 UTC
I don't think this is applicable to Fedora.  The original report was here:

http://www.openwall.com/lists/oss-security/2015/10/27/11

and that pointed out that impacted versions are only before 3.19 with a particular commit applied (89c22d8c3b27 ("net: Fix skb
csum races when peeking")) but are lacking the ioviter conversion.  The patch referenced in the initial comment also clearly spells this out.

All Fedora releases are on 4.1.y or newer, and should not be affected by this.

Comment 5 Vladis Dronov 2015-11-30 14:55:35 UTC
Statement:

This issue does not affect the Linux kernel packages as shipped with Red Hat Enterprise Linux 5, 6, 7 and MRG-2, as the code introduced the flaw is not present in these products.